--- gcc-4.0.0.orig/libstdc++-v3/include/ext/ropeimpl.h	2 Sep 2004 18:22:20 -0000	1.31
+++ gcc-4.0.0/libstdc++-v3/include/ext/ropeimpl.h	28 Apr 2005 08:01:34 -0000	1.31.34.1
@@ -116,7 +116,7 @@
     _Rope_iterator_base<_CharT, _Alloc>::
     _S_setcache(_Rope_iterator_base<_CharT, _Alloc>& __x)
     {
-      const _RopeRep* __path[_Rope_constants::_S_max_rope_depth + 1];
+      const _RopeRep* __path[int(_Rope_constants::_S_max_rope_depth) + 1];
       const _RopeRep* __curr_rope;
       int __curr_depth = -1;  /* index into path    */
       size_t __curr_start_pos = 0;
@@ -175,7 +175,7 @@
       // Copy last section of path into _M_path_end.
       {
 	int __i = -1;
-	int __j = __curr_depth + 1 - _S_path_cache_len;
+	int __j = __curr_depth + 1 - int(_S_path_cache_len);
 
 	if (__j < 0) __j = 0;
 	while (__j <= __curr_depth)
@@ -236,10 +236,10 @@
       while (_Rope_constants::_S_concat == __current_node->_M_tag)
 	{
 	  ++__current_index;
-	  if (_S_path_cache_len == __current_index)
+	  if (int(_S_path_cache_len) == __current_index)
 	    {
 	      int __i;
-	      for (__i = 0; __i < _S_path_cache_len-1; __i++)
+	      for (__i = 0; __i < int(_S_path_cache_len) - 1; __i++)
 		__x._M_path_end[__i] = __x._M_path_end[__i+1];
 	      --__current_index;
 	    }
@@ -500,8 +500,9 @@
 							      get_allocator());
       size_t __depth = __result->_M_depth;
       
-      if (__depth > 20 && (__result->_M_size < 1000
-			   || __depth > _Rope_constants::_S_max_rope_depth))
+      if (__depth > 20
+	  && (__result->_M_size < 1000
+	      || __depth > size_t(_Rope_constants::_S_max_rope_depth)))
 	{
 	  _RopeRep* __balanced;
 
@@ -540,7 +541,7 @@
 	return __STL_ROPE_FROM_UNOWNED_CHAR_PTR(__s, __slen,
 						__r->get_allocator());
       if (_Rope_constants::_S_leaf == __r->_M_tag
-	  && __r->_M_size + __slen <= _S_copy_max)
+	  && __r->_M_size + __slen <= size_t(_S_copy_max))
 	{
 	  __result = _S_leaf_concat_char_iter((_RopeLeaf*)__r, __s, __slen);
 	  return __result;
@@ -551,7 +552,7 @@
 	{
 	  _RopeLeaf* __right =
 	    (_RopeLeaf* )(((_RopeConcatenation* )__r)->_M_right);
-	  if (__right->_M_size + __slen <= _S_copy_max)
+	  if (__right->_M_size + __slen <= size_t(_S_copy_max))
 	    {
 	      _RopeRep* __left = ((_RopeConcatenation*)__r)->_M_left;
 	      _RopeRep* __nright =
@@ -603,7 +604,7 @@
 	  __r->_M_ref_count = 2;      // One more than before
 	  return __r;
 	}
-      if (__orig_size + __slen <= _S_copy_max
+      if (__orig_size + __slen <= size_t(_S_copy_max)
 	  && _Rope_constants::_S_leaf == __r->_M_tag)
 	{
 	  __result = _S_destr_leaf_concat_char_iter((_RopeLeaf*)__r, __s, 
@@ -615,7 +616,7 @@
 	  _RopeLeaf* __right = (_RopeLeaf*)(((_RopeConcatenation*)
 					     __r)->_M_right);
 	  if (_Rope_constants::_S_leaf == __right->_M_tag
-	      && __right->_M_size + __slen <= _S_copy_max)
+	      && __right->_M_size + __slen <= size_t(_S_copy_max))
 	    {
 	      _RopeRep* __new_right =
 		_S_destr_leaf_concat_char_iter(__right, __s, __slen);
@@ -668,7 +669,7 @@
 	{
 	  if (_Rope_constants::_S_leaf == __left->_M_tag)
 	    {
-	      if (__right->_M_size + __left->_M_size <= _S_copy_max)
+	      if (__right->_M_size + __left->_M_size <= size_t(_S_copy_max))
 		return _S_leaf_concat_char_iter((_RopeLeaf*)__left,
 						((_RopeLeaf*)__right)->_M_data,
 						__right->_M_size);
@@ -679,7 +680,8 @@
 	    {
 	      _RopeLeaf* __leftright =
 		(_RopeLeaf*)(((_RopeConcatenation*)__left)->_M_right);
-	      if (__leftright->_M_size + __right->_M_size <= _S_copy_max)
+	      if (__leftright->_M_size
+		  + __right->_M_size <= size_t(_S_copy_max))
 		{
 		  _RopeRep* __leftleft = ((_RopeConcatenation*)__left)->_M_left;
 		  _RopeRep* __rest = _S_leaf_concat_char_iter(__leftright,
@@ -1184,7 +1186,7 @@
   template <class _CharT, class _Alloc>
     const unsigned long
     rope<_CharT, _Alloc>::
-    _S_min_len[_Rope_constants::_S_max_rope_depth + 1] = {
+    _S_min_len[int(_Rope_constants::_S_max_rope_depth) + 1] = {
       /* 0 */1, /* 1 */2, /* 2 */3, /* 3 */5, /* 4 */8, /* 5 */13, /* 6 */21,
       /* 7 */34, /* 8 */55, /* 9 */89, /* 10 */144, /* 11 */233, /* 12 */377,
       /* 13 */610, /* 14 */987, /* 15 */1597, /* 16 */2584, /* 17 */4181,
@@ -1203,7 +1205,7 @@
     rope<_CharT, _Alloc>::
     _S_balance(_RopeRep* __r)
     {
-      _RopeRep* __forest[_Rope_constants::_S_max_rope_depth + 1];
+      _RopeRep* __forest[int(_Rope_constants::_S_max_rope_depth) + 1];
       _RopeRep* __result = 0;
       int __i;
       // Invariant:
@@ -1212,12 +1214,12 @@
       // __forest[__i]._M_depth = __i
       // References from forest are included in refcount.
       
-      for (__i = 0; __i <= _Rope_constants::_S_max_rope_depth; ++__i)
+      for (__i = 0; __i <= int(_Rope_constants::_S_max_rope_depth); ++__i)
 	__forest[__i] = 0;
       try
 	{
 	  _S_add_to_forest(__r, __forest);
-	  for (__i = 0; __i <= _Rope_constants::_S_max_rope_depth; ++__i)
+	  for (__i = 0; __i <= int(_Rope_constants::_S_max_rope_depth); ++__i)
 	    if (0 != __forest[__i])
 	      {
 #ifndef __GC
@@ -1232,12 +1234,12 @@
 	}
       catch(...)
 	{
-	  for(__i = 0; __i <= _Rope_constants::_S_max_rope_depth; __i++)
+	  for(__i = 0; __i <= int(_Rope_constants::_S_max_rope_depth); __i++)
 	    _S_unref(__forest[__i]);
 	  __throw_exception_again;
 	}
       
-      if (__result->_M_depth > _Rope_constants::_S_max_rope_depth)
+      if (__result->_M_depth > int(_Rope_constants::_S_max_rope_depth))
 	__throw_length_error(__N("rope::_S_balance"));
       return(__result);
     }
@@ -1305,7 +1307,7 @@
 	      __forest[__i]->_M_unref_nonnil();
 	      __forest[__i] = 0;
 	    }
-	  if (__i == _Rope_constants::_S_max_rope_depth
+	  if (__i == int(_Rope_constants::_S_max_rope_depth)
 	      || __insertee->_M_size < _S_min_len[__i+1])
 	    {
 	      __forest[__i] = __insertee;
--- gcc-4.0.0.orig/libstdc++-v3/include/tr1/type_traits	8 Mar 2005 18:24:16 -0000	1.33.2.4
+++ gcc-4.0.0/libstdc++-v3/include/tr1/type_traits	28 Apr 2005 22:40:43 -0000	1.33.2.6
@@ -366,14 +366,11 @@
 
   template<typename _Tp>
     struct has_trivial_copy
-    : public integral_constant<bool, (is_pod<_Tp>::value 
-				      && !is_volatile<_Tp>::value)> { };
+    : public integral_constant<bool, is_pod<_Tp>::value> { };
 
   template<typename _Tp>
     struct has_trivial_assign
-    : public integral_constant<bool, (is_pod<_Tp>::value
-				      && !is_const<_Tp>::value
-				      && !is_volatile<_Tp>::value)> { };
+    : public integral_constant<bool, is_pod<_Tp>::value> { };
 
   template<typename _Tp>
     struct has_trivial_destructor
@@ -385,14 +382,11 @@
 
   template<typename _Tp>
     struct has_nothrow_copy
-    : public integral_constant<bool, (is_pod<_Tp>::value 
-				      && !is_volatile<_Tp>::value)> { };
+    : public integral_constant<bool, is_pod<_Tp>::value> { };
 
   template<typename _Tp>
     struct has_nothrow_assign
-    : public integral_constant<bool, (is_pod<_Tp>::value
-				      && !is_const<_Tp>::value
-				      && !is_volatile<_Tp>::value)> { };
+    : public integral_constant<bool, is_pod<_Tp>::value> { };
 
   template<typename>
     struct has_virtual_destructor
@@ -507,7 +501,8 @@
     };
 
   template<typename _From, typename _To,
-	   bool = (is_function<_To>::value || is_array<_To>::value
+	   bool = (is_void<_From>::value || is_void<_To>::value
+		   || is_function<_To>::value || is_array<_To>::value
 		   // This special case is here only to avoid warnings.		   
 		   || (is_floating_point<typename
 		       remove_reference<_From>::type>::value
@@ -521,7 +516,9 @@
 
   template<typename _From, typename _To>
     struct __is_convertible_helper<_From, _To, true>
-    { static const bool __value = __is_int_or_cref<_To>::__value; };
+    { static const bool __value = (is_void<_To>::value
+				   || (__is_int_or_cref<_To>::__value
+				       && !is_void<_From>::value)); };
 
   template<typename _From, typename _To>
     struct is_convertible
--- gcc-4.0.0.orig/libstdc++-v3/testsuite/testsuite_tr1.h	1 Apr 2005 04:24:33 -0000	1.9.2.4
+++ gcc-4.0.0/libstdc++-v3/testsuite/testsuite_tr1.h	27 Apr 2005 15:10:22 -0000	1.9.2.5
@@ -62,40 +62,6 @@
       return ret;
     }
 
-  template<template<typename> class Property,
-           typename Type>
-    bool
-    test_copy_property(bool value)
-    {
-      bool ret = true;
-      ret &= Property<Type>::value == value;
-      ret &= Property<const Type>::value == value;
-      ret &= Property<volatile Type>::value == !value;
-      ret &= Property<const volatile Type>::value == !value;
-      ret &= Property<Type>::type::value == value;
-      ret &= Property<const Type>::type::value == value;
-      ret &= Property<volatile Type>::type::value == !value;
-      ret &= Property<const volatile Type>::type::value == !value;
-      return ret;
-    }
-
-  template<template<typename> class Property,
-           typename Type>
-    bool
-    test_assign_property(bool value)
-    {
-      bool ret = true;
-      ret &= Property<Type>::value == value;
-      ret &= Property<const Type>::value == !value;
-      ret &= Property<volatile Type>::value == !value;
-      ret &= Property<const volatile Type>::value == !value;
-      ret &= Property<Type>::type::value == value;
-      ret &= Property<const Type>::type::value == !value;
-      ret &= Property<volatile Type>::type::value == !value;
-      ret &= Property<const volatile Type>::type::value == !value;
-      return ret;
-    }
-
   template<template<typename, typename> class Relationship,
            typename Type1, typename Type2>
     bool
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/libstdc++-v3/testsuite/22_locale/num_put/put/char/20914.cc	25 Apr 2005 09:33:40 -0000	1.1.4.1
@@ -0,0 +1,79 @@
+// 2005-04-17  Paolo Carlini  <pcarlini@suse.de>
+
+// Copyright (C) 2005 Free Software Foundation
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING.  If not, write to the Free
+// Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
+// USA.
+
+// 22.2.2.2.1  num_put members
+
+#include <locale>
+#include <sstream>
+#include <testsuite_hooks.h>
+
+// libstdc++/20914
+void test01()
+{
+  using namespace std;
+  bool test __attribute__((unused)) = true;
+
+  // A locale that expects grouping.
+  locale loc_de = __gnu_test::try_named_locale("de_DE");
+
+  const string empty;
+  string result;
+
+  ostringstream oss;
+  oss.imbue(loc_de);
+  const num_put<char>& np = use_facet<num_put<char> >(oss.getloc()); 
+
+  long l0 = -300000;
+  long l1 = 300;
+  double d0 = -300000;
+  double d1 = 300;
+
+  oss.str(empty);
+  oss.clear();
+  np.put(oss.rdbuf(), oss, '*', l0);
+  result = oss.str();
+  VERIFY( result == "-300.000" );
+
+  oss.str(empty);
+  oss.clear();
+  np.put(oss.rdbuf(), oss, '*', d0);
+  result = oss.str();
+  VERIFY( result == "-300.000" );
+
+  oss.str(empty);
+  oss.clear();
+  oss.setf(ios::showpos);
+  np.put(oss.rdbuf(), oss, '*', l1);
+  result = oss.str();
+  VERIFY( result == "+300" );
+
+  oss.str(empty);
+  oss.clear();
+  oss.setf(ios::showpos);
+  np.put(oss.rdbuf(), oss, '*', d1);
+  result = oss.str();
+  VERIFY( result == "+300" );
+}
+
+int main()
+{
+  test01();
+  return 0;
+}
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/libstdc++-v3/testsuite/22_locale/num_put/put/wchar_t/20914.cc	25 Apr 2005 09:33:41 -0000	1.1.4.1
@@ -0,0 +1,79 @@
+// 2005-04-17  Paolo Carlini  <pcarlini@suse.de>
+
+// Copyright (C) 2005 Free Software Foundation
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING.  If not, write to the Free
+// Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
+// USA.
+
+// 22.2.2.2.1  num_put members
+
+#include <locale>
+#include <sstream>
+#include <testsuite_hooks.h>
+
+// libstdc++/20914
+void test01()
+{
+  using namespace std;
+  bool test __attribute__((unused)) = true;
+
+  // A locale that expects grouping.
+  locale loc_de = __gnu_test::try_named_locale("de_DE");
+
+  const wstring empty;
+  wstring result;
+
+  wostringstream oss;
+  oss.imbue(loc_de);
+  const num_put<wchar_t>& np = use_facet<num_put<wchar_t> >(oss.getloc()); 
+
+  long l0 = -300000;
+  long l1 = 300;
+  double d0 = -300000;
+  double d1 = 300;
+
+  oss.str(empty);
+  oss.clear();
+  np.put(oss.rdbuf(), oss, L'*', l0);
+  result = oss.str();
+  VERIFY( result == L"-300.000" );
+
+  oss.str(empty);
+  oss.clear();
+  np.put(oss.rdbuf(), oss, L'*', d0);
+  result = oss.str();
+  VERIFY( result == L"-300.000" );
+
+  oss.str(empty);
+  oss.clear();
+  oss.setf(ios::showpos);
+  np.put(oss.rdbuf(), oss, L'*', l1);
+  result = oss.str();
+  VERIFY( result == L"+300" );
+
+  oss.str(empty);
+  oss.clear();
+  oss.setf(ios::showpos);
+  np.put(oss.rdbuf(), oss, L'*', d1);
+  result = oss.str();
+  VERIFY( result == L"+300" );
+}
+
+int main()
+{
+  test01();
+  return 0;
+}
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/libstdc++-v3/testsuite/23_containers/vector/bool/21244.cc	27 Apr 2005 16:02:27 -0000	1.1.2.1
@@ -0,0 +1,36 @@
+// Copyright (C) 2005 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2, or (at your option)
+// any later version.
+ 
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+ 
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING.  If not, write to the Free
+// Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
+// USA.
+
+#include <vector>
+
+// { dg-do compile }
+
+class Foo
+{
+};
+
+template<class T> Foo operator/(const Foo& arg1, T arg2)
+{
+  return Foo();
+}
+
+// libstdc++/21244
+void foo()
+{
+  std::vector<bool> bar(1);
+}
--- gcc-4.0.0.orig/libstdc++-v3/testsuite/tr1/4_metaprogramming/relationships_between_types/is_convertible/is_convertible.cc	23 Feb 2005 17:23:44 -0000	1.1
+++ gcc-4.0.0/libstdc++-v3/testsuite/tr1/4_metaprogramming/relationships_between_types/is_convertible/is_convertible.cc	28 Apr 2005 22:40:43 -0000	1.1.2.1
@@ -54,6 +54,10 @@
   VERIFY( (test_relationship<is_convertible, DerivedType*, ClassType*>(true)) );
   VERIFY( (test_relationship<is_convertible, DerivedType&, ClassType&>(true)) );
 
+  VERIFY( (test_relationship<is_convertible, void, void>(true)) );
+  VERIFY( (test_relationship<is_convertible, int, void>(true)) );
+  VERIFY( (test_relationship<is_convertible, int[4], void>(true)) );  
+
   // Negative tests.
   VERIFY( (test_relationship<is_convertible, const int*, int*>(false)) );
   VERIFY( (test_relationship<is_convertible, int*, float*>(false)) );
@@ -69,7 +73,11 @@
   VERIFY( (test_relationship<is_convertible, int, ClassType>(false)) );
   VERIFY( (test_relationship<is_convertible, ClassType, DerivedType>(false)) );
   VERIFY( (test_relationship<is_convertible, ClassType*, DerivedType*>(false)) );
-  VERIFY( (test_relationship<is_convertible, ClassType&, DerivedType&>(false)) );  
+  VERIFY( (test_relationship<is_convertible, ClassType&, DerivedType&>(false)) );
+
+  VERIFY( (test_relationship<is_convertible, void, int>(false)) );
+  VERIFY( (test_relationship<is_convertible, void, float>(false)) );  
+  VERIFY( (test_relationship<is_convertible, void, int(*)(int)>(false)) );  
 }
 
 int main()
--- gcc-4.0.0.orig/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_nothrow_assign/has_nothrow_assign.cc	31 Dec 2004 18:15:21 -0000	1.2
+++ gcc-4.0.0/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_nothrow_assign/has_nothrow_assign.cc	27 Apr 2005 15:10:26 -0000	1.2.20.1
@@ -1,6 +1,6 @@
 // 2004-12-30  Paolo Carlini  <pcarlini@suse.de>
 //
-// Copyright (C) 2004 Free Software Foundation, Inc.
+// Copyright (C) 2004, 2005 Free Software Foundation, Inc.
 //
 // This file is part of the GNU ISO C++ Library.  This library is free
 // software; you can redistribute it and/or modify it under the
@@ -30,23 +30,21 @@
   using std::tr1::has_nothrow_assign;
   using namespace __gnu_test;
 
-  VERIFY( (test_assign_property<has_nothrow_assign, void>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, int>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, float>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, EnumType>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, int*>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, int(*)(int)>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, int (ClassType::*)>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign,
-	   int (ClassType::*) (int)>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, int[2]>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, float[][3]>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, EnumType[2][3][4]>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, int*[3]>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign, int(*[][2])(int)>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign,
-	   int (ClassType::*[2][3])>(true)) );
-  VERIFY( (test_assign_property<has_nothrow_assign,
+  VERIFY( (test_category<has_nothrow_assign, void>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, float>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, EnumType>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int*>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int(*)(int)>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int (ClassType::*)>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int (ClassType::*) (int)>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int[2]>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, float[][3]>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, EnumType[2][3][4]>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int*[3]>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int(*[][2])(int)>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, int (ClassType::*[2][3])>(true)) );
+  VERIFY( (test_category<has_nothrow_assign, 
 	   int (ClassType::*[][2][3]) (int)>(true)) );
 }
 
--- gcc-4.0.0.orig/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_nothrow_copy/has_nothrow_copy.cc	31 Dec 2004 18:15:21 -0000	1.2
+++ gcc-4.0.0/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_nothrow_copy/has_nothrow_copy.cc	27 Apr 2005 15:10:27 -0000	1.2.20.1
@@ -1,6 +1,6 @@
 // 2004-12-30  Paolo Carlini  <pcarlini@suse.de>
 //
-// Copyright (C) 2004 Free Software Foundation, Inc.
+// Copyright (C) 2004, 2005 Free Software Foundation, Inc.
 //
 // This file is part of the GNU ISO C++ Library.  This library is free
 // software; you can redistribute it and/or modify it under the
@@ -30,23 +30,21 @@
   using std::tr1::has_nothrow_copy;
   using namespace __gnu_test;
 
-  VERIFY( (test_copy_property<has_nothrow_copy, void>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, int>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, float>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, EnumType>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, int*>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, int(*)(int)>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, int (ClassType::*)>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy,
-	   int (ClassType::*) (int)>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, int[2]>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, float[][3]>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, EnumType[2][3][4]>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, int*[3]>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy, int(*[][2])(int)>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy,
-	   int (ClassType::*[2][3])>(true)) );
-  VERIFY( (test_copy_property<has_nothrow_copy,
+  VERIFY( (test_category<has_nothrow_copy, void>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, float>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, EnumType>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int*>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int(*)(int)>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int (ClassType::*)>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int (ClassType::*) (int)>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int[2]>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, float[][3]>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, EnumType[2][3][4]>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int*[3]>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int(*[][2])(int)>(true)) );
+  VERIFY( (test_category<has_nothrow_copy, int (ClassType::*[2][3])>(true)) );
+  VERIFY( (test_category<has_nothrow_copy,
 	   int (ClassType::*[][2][3]) (int)>(true)) );
 }
 
--- gcc-4.0.0.orig/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_trivial_assign/has_trivial_assign.cc	31 Dec 2004 18:15:22 -0000	1.2
+++ gcc-4.0.0/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_trivial_assign/has_trivial_assign.cc	27 Apr 2005 15:10:27 -0000	1.2.20.1
@@ -1,6 +1,6 @@
 // 2004-12-30  Paolo Carlini  <pcarlini@suse.de>
 //
-// Copyright (C) 2004 Free Software Foundation, Inc.
+// Copyright (C) 2004, 2005 Free Software Foundation, Inc.
 //
 // This file is part of the GNU ISO C++ Library.  This library is free
 // software; you can redistribute it and/or modify it under the
@@ -30,23 +30,21 @@
   using std::tr1::has_trivial_assign;
   using namespace __gnu_test;
 
-  VERIFY( (test_assign_property<has_trivial_assign, void>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, int>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, float>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, EnumType>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, int*>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, int(*)(int)>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, int (ClassType::*)>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign,
-	   int (ClassType::*) (int)>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, int[2]>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, float[][3]>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, EnumType[2][3][4]>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, int*[3]>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign, int(*[][2])(int)>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign,
-	   int (ClassType::*[2][3])>(true)) );
-  VERIFY( (test_assign_property<has_trivial_assign,
+  VERIFY( (test_category<has_trivial_assign, void>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int>(true)) );
+  VERIFY( (test_category<has_trivial_assign, float>(true)) );
+  VERIFY( (test_category<has_trivial_assign, EnumType>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int*>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int(*)(int)>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int (ClassType::*)>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int (ClassType::*) (int)>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int[2]>(true)) );
+  VERIFY( (test_category<has_trivial_assign, float[][3]>(true)) );
+  VERIFY( (test_category<has_trivial_assign, EnumType[2][3][4]>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int*[3]>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int(*[][2])(int)>(true)) );
+  VERIFY( (test_category<has_trivial_assign, int (ClassType::*[2][3])>(true)) );
+  VERIFY( (test_category<has_trivial_assign,
 	   int (ClassType::*[][2][3]) (int)>(true)) );
 }
 
--- gcc-4.0.0.orig/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_trivial_copy/has_trivial_copy.cc	31 Dec 2004 18:15:22 -0000	1.2
+++ gcc-4.0.0/libstdc++-v3/testsuite/tr1/4_metaprogramming/type_properties/has_trivial_copy/has_trivial_copy.cc	27 Apr 2005 15:10:28 -0000	1.2.20.1
@@ -1,6 +1,6 @@
 // 2004-12-30  Paolo Carlini  <pcarlini@suse.de>
 //
-// Copyright (C) 2004 Free Software Foundation, Inc.
+// Copyright (C) 2004, 2005 Free Software Foundation, Inc.
 //
 // This file is part of the GNU ISO C++ Library.  This library is free
 // software; you can redistribute it and/or modify it under the
@@ -30,23 +30,21 @@
   using std::tr1::has_trivial_copy;
   using namespace __gnu_test;
 
-  VERIFY( (test_copy_property<has_trivial_copy, void>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, int>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, float>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, EnumType>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, int*>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, int(*)(int)>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, int (ClassType::*)>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy,
-	   int (ClassType::*) (int)>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, int[2]>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, float[][3]>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, EnumType[2][3][4]>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, int*[3]>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy, int(*[][2])(int)>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy,
-	   int (ClassType::*[2][3])>(true)) );
-  VERIFY( (test_copy_property<has_trivial_copy,
+  VERIFY( (test_category<has_trivial_copy, void>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int>(true)) );
+  VERIFY( (test_category<has_trivial_copy, float>(true)) );
+  VERIFY( (test_category<has_trivial_copy, EnumType>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int*>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int(*)(int)>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int (ClassType::*)>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int (ClassType::*) (int)>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int[2]>(true)) );
+  VERIFY( (test_category<has_trivial_copy, float[][3]>(true)) );
+  VERIFY( (test_category<has_trivial_copy, EnumType[2][3][4]>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int*[3]>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int(*[][2])(int)>(true)) );
+  VERIFY( (test_category<has_trivial_copy, int (ClassType::*[2][3])>(true)) );
+  VERIFY( (test_category<has_trivial_copy,
 	   int (ClassType::*[][2][3]) (int)>(true)) );
 }
 
